=== debian/rules ===
#!/usr/bin/make -f
SHELL = /bin/sh -e

# get DEB_VERSION
include /usr/share/dpkg/pkg-info.mk
# get DEB_HOST_ARCH DEB_HOST_ARCH_OS DEB_HOST_GNU_TYPE DEB_HOST_MULTIARCH DEB_BUILD_GNU_TYPE
include /usr/share/dpkg/architecture.mk
# get CFLAGS LDFLAGS etc
include /usr/share/dpkg/buildflags.mk

libdir = /usr/lib/${DEB_HOST_MULTIARCH}

ifeq ($(shell dpkg-vendor --derives-from Ubuntu && echo yes),yes)
VENDOR := UBUNTU
DEB_BUILD_PARALLEL = yes
else
VENDOR := DEBIAN
endif

AUTOGENERATED:= qemu-block-extra.prerm qemu-block-extra.postrm
PKGVERSION := $(shell printf "Debian ${DEB_VERSION}" | tr --complement '[:alnum:]+-.~' '_')

# support parallel build using DEB_BUILD_OPTIONS=parallel=N
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
  MAKEFLAGS += -j$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
endif

# verbose build
V ?= 1

# list of packages we're supposed to build
BUILD_PACKAGES = $(call dpkg_late_eval,BUILD_PACKAGES,dh_listpackages)

enable_system = $(if $(filter qemu-system,${BUILD_PACKAGES}),enable,disable)
enable_linux_user = $(if $(filter qemu-user,${BUILD_PACKAGES}),enable,disable)

FIRMWAREPATH = /usr/share/qemu:/usr/share/seabios:/usr/lib/ipxe/qemu

ALPHAEV67_CROSSPFX = alpha-linux-gnu-
PPC64_CROSSPFX = powerpc64-linux-gnu-

# we add another set of configure options from debian/control
common_configure_opts = \
	--with-pkgversion="Debian $(DEB_VERSION)" \
	--extra-cflags="$(CFLAGS) $(CPPFLAGS)" --extra-ldflags="$(LDFLAGS) -Wl,--as-needed" \
	--prefix=/usr \
	--sysconfdir=/etc \
	--libdir=${libdir} \
	--libexecdir=/usr/lib/qemu \
	--firmwarepath=${FIRMWAREPATH} \
	--localstatedir=/var \
	--disable-blobs \
	--disable-strip \
	--interp-prefix=/etc/qemu-binfmt/%M \
	--localstatedir=/var \
	--with-git-submodules=ignore \

# Cross compiling support
ifneq ($(DEB_BUILD_GNU_TYPE), $(DEB_HOST_GNU_TYPE))
common_configure_opts  += --cross-prefix=$(DEB_HOST_GNU_TYPE)-
endif

ifeq ($(DEB_TARGET_ARCH), hppa)
# allow configure to run on unsupported arches to build qemu-utils and the like
common_configure_opts += --enable-tcg-interpreter
endif

ifeq (${enable_system},enable)

# list of system (softmmu) targets, from ./configure
system_targets = \
 i386 x86_64 alpha aarch64 arm cris lm32 hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el moxie nios2 or1k ppc ppc64 riscv32 riscv64 \
 sh4 sh4eb sparc sparc64 s390x tricore xtensa xtensaeb unicore32

# qemu-system subpackages, from d/control
ifeq ($(VENDOR),UBUNTU)
sys_systems = arm mips ppc sparc x86 s390x
else
sys_systems = arm mips ppc sparc x86
endif
systems = ${sys_systems} misc
sysarch_arm   = $(filter aarch64 arm,${system_targets})
sysarch_mips  = $(filter mips mipsel mips64 mips64el,${system_targets})
sysarch_ppc   = $(filter ppc ppc64,${system_targets})
sysarch_sparc = $(filter sparc sparc64,${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})
sysarch_s390x = $(filter s390x,${system_targets})
sysarch_misc  = $(filter-out $(foreach s,${sys_systems},${sysarch_$s}),${system_targets})
sysarch_x86   = $(filter i386 x86_64,${system_targets})

else

systems =

endif # enable_system

ifeq (${enable_linux_user},enable)

# list of linux-user targets, from ./configure
user_targets = \
 i386 x86_64 alpha aarch64 aarch64_be arm armeb cris hppa m68k microblaze microblazeel \
 mips mipsel mips64 mips64el mipsn32 mipsn32el nios2 or1k \
 ppc ppc64 ppc64abi32 ppc64le riscv32 riscv64 sh4 sh4eb sparc sparc64 sparc32plus \
 s390x tilegx xtensa xtensaeb

endif	# enable_linux_user

b/configure-stamp: configure
	dh_testdir

	for f in ${AUTOGENERATED} ; do \
        sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' \
	        -e 's%@PKGVERSION@%${PKGVERSION}%g' \
			< debian/$$f.in  > debian/$$f ; \
    done

	# system build
	rm -rf b/qemu; mkdir -p b/qemu
	cd b/qemu && \
	    ../../configure ${common_configure_opts} --disable-user \
		--${enable_system}-system \
		--${enable_linux_user}-linux-user \
		--disable-xen \
		--enable-modules \
		--enable-module-upgrades \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu/config.log; exit 1; }

# switch some simple UI and simple audio modules to be built-ins,
# but keep more complex to be modules to move to a separate package
	sed -i -r 's/(CONFIG_(CURSES|-GTK|-SDL|AUDIO_(-PA|OSS|ALSA|-SDL)))=m/\1=y/' \
		b/qemu/config-host.mak

ifeq ($(VENDOR),UBUNTU)
ifneq ($(filter $(DEB_HOST_ARCH),amd64 i386),)
# like above but with:
#  --enable-xen
#  --disable-linux-user (not needed for this binary)
#  reduced --target-list as needed for xen
#  xen can only be configured on x86, so skip other build architectures
	# system build for qemu-system-x86-xen
	rm -rf b/qemu-xen; mkdir -p b/qemu-xen
	cd b/qemu-xen && \
	    ../../configure ${common_configure_opts} --disable-user \
		--${enable_system}-system \
		--disable-linux-user \
		--enable-xen \
		--target-list="aarch64-softmmu arm-softmmu i386-softmmu x86_64-softmmu"
		--enable-modules \
		--enable-module-upgrades \
		$(shell sh debian/extract-config-opts \
		    $(DEB_HOST_ARCH_OS)-$(DEB_HOST_ARCH) debian/control) \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu-xen/config.log; exit 1; }
# same config as the main build.
	sed -i -r 's/(CONFIG_(CURSES|-GTK|-SDL|AUDIO_(-PA|OSS|ALSA|-SDL)))=m/\1=y/' \
		b/qemu-xen/config-host.mak
endif
endif

ifneq ($(filter $(DEB_HOST_ARCH),amd64),)
	# minimal system (for qboot/microvm - https://github.com/bonzini/qboot)
	rm -rf b/qemu-microvm; mkdir -p b/qemu-microvm
	cd b/qemu-microvm && \
		../../configure ${common_configure_opts} --disable-user \
		--enable-system --enable-kvm \
		--disable-linux-user --disable-modules --disable-docs \
		--disable-libssh --disable-tcmalloc --disable-glusterfs \
		--disable-seccomp --disable-bzip2 --disable-slirp --disable-vde \
		--disable-netmap --disable-hax --disable-hvf --disable-whpx \
		--disable-cocoa --disable-lzfse \
		--disable-guest-agent --disable-guest-agent-msi --disable-tools \
		--disable-gnutls --disable-gcrypt --disable-auth-pam \
		--disable-replication --disable-vxhs --disable-bochs --disable-cloop \
		--disable-dmg --disable-parallels --disable-qed --disable-vdi \
		--disable-sheepdog --disable-capstone --disable-libpmem --disable-plugins \
		--disable-snappy --disable-lzo --disable-usb-redir \
		--disable-libusb --disable-smartcard --disable-libnfs  \
		--disable-libiscsi --disable-rbd  --disable-spice --disable-attr \
		--disable-cap-ng --disable-linux-aio --disable-brlapi \
		--disable-virglrenderer --disable-vnc-jpeg --disable-vnc-sasl \
		--disable-vnc-png --disable-rdma --disable-pvrdma --disable-bluez \
		--disable-fdt --disable-curl --disable-curses --disable-sdl \
		--disable-gtk  --disable-tpm --disable-vte --disable-vnc  \
		--disable-xen --disable-opengl \
		--target-list="x86_64-softmmu i386-softmmu"\
		--audio-drv-list="" --disable-xfsctl --disable-vvfat \
		--disable-iconv --disable-nettle \
		--disable-tcg-interpreter --disable-tcg \
		--without-default-devices \
		$(QEMU_CONFIGURE_OPTIONS) || \
	 { echo ===== CONFIGURE FAILED ===; tail -n 50 b/qemu-microvm/config.log; exit 1; }
endif

ifeq ($(enable_linux_user),enable)
# do not use debian/configure-opts here, all optional stuff will be enabled
# automatically, dependencies are already verified in the main build
	rm -rf b/user-static; mkdir b/user-static
	cd b/user-static && \
	    ../../configure ${common_configure_opts} \
		--static --disable-system --disable-xen \
		--target-list="$(addsuffix -linux-user,${user_targets})"
endif
	touch $@

build-arch: b/build-stamp
b/build-stamp: b/configure-stamp
	dh_testdir

	# system and utils build
	$(MAKE) -C b/qemu V=${V}
ifeq (${enable_system},enable)
	rm -f b/qemu/pc-bios/bamboo.dtb b/qemu/pc-bios/canyonlands.dtb
	dtc -o b/qemu/pc-bios/bamboo.dtb pc-bios/bamboo.dts
